com.fasterxml.jackson.databind.deser.std

## Class UntypedObjectDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.std.UntypedObjectDeserializer

All Implemented Interfaces:
  ContextualDeserializer, ResolvableDeserializer, Serializable

    public class UntypedObjectDeserializer
    extends StdDeserializer<Object>
    implements ResolvableDeserializer, ContextualDeserializer

Deserializer implementation that is used if it is necessary to bind content of "unknown" type; something declared as basic `Object` (either explicitly, or due to type erasure). If so, "natural" mapping is used to convert JSON values to their natural Java object matches: JSON arrays to Java `List`s (or, if configured, Object[]), JSON objects to `Map`s, numbers to `Number`s, booleans to `Boolean`s and strings to `String` (and nulls to nulls).

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected JsonDeserializer<Object>` `_listDeserializer`
`protected JsonDeserializer<Object>` `_mapDeserializer`
`protected JsonDeserializer<Object>` `_numberDeserializer`
`protected JsonDeserializer<Object>` `_stringDeserializer`
`static UntypedObjectDeserializer` `instance` Deprecated. Since 2.3, construct a new instance, needs to be resolved

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass`

### Constructor Summary

Constructors
Constructor and Description
`UntypedObjectDeserializer()`
`UntypedObjectDeserializer(UntypedObjectDeserializer base, JsonDeserializer<?> mapDeser, JsonDeserializer<?> listDeser, JsonDeserializer<?> stringDeser, JsonDeserializer<?> numberDeser)`

### Method Summary

Methods
`protected JsonDeserializer<Object>` `_findCustomDeser(DeserializationContext ctxt, JavaType type)`
`protected JsonDeserializer<?>` `_withResolved(JsonDeserializer<?> mapDeser, JsonDeserializer<?> listDeser, JsonDeserializer<?> stringDeser, JsonDeserializer<?> numberDeser)`
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`Object` `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`protected Object` `mapArray(JsonParser jp, DeserializationContext ctxt)` Method called to map a JSON Array into a Java value.
`protected Object[]` `mapArrayToArray(JsonParser jp, DeserializationContext ctxt)` Method called to map a JSON Array into a Java Object array (Object[]).
`protected Object` `mapObject(JsonParser jp, DeserializationContext ctxt)` Method called to map a JSON Object into a Java value.
`void` `resolve(DeserializationContext ctxt)` We need to implement this method to properly find things to delegate to: it can not be done earlier since delegated deserializers almost certainly require access to this instance (at least "List" and "Map" ones)

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_hasTextualNull, _parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, getValueType, handledType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, findBackReference, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### instance

    @Deprecated
    public static final UntypedObjectDeserializer instance

Deprecated. Since 2.3, construct a new instance, needs to be resolved

#### _mapDeserializer

    protected JsonDeserializer<Object> _mapDeserializer

#### _listDeserializer

    protected JsonDeserializer<Object> _listDeserializer

#### _stringDeserializer

    protected JsonDeserializer<Object> _stringDeserializer

#### _numberDeserializer

    protected JsonDeserializer<Object> _numberDeserializer

### Constructor Detail

#### UntypedObjectDeserializer

    public UntypedObjectDeserializer()

#### UntypedObjectDeserializer

    public UntypedObjectDeserializer(UntypedObjectDeserializer base,
                             JsonDeserializer<?> mapDeser,
                             JsonDeserializer<?> listDeser,
                             JsonDeserializer<?> stringDeser,
                             JsonDeserializer<?> numberDeser)

### Method Detail

#### resolve

    public void resolve(DeserializationContext ctxt)
                 throws JsonMappingException

We need to implement this method to properly find things to delegate to: it can not be done earlier since delegated deserializers almost certainly require access to this instance (at least "List" and "Map" ones)

Specified by:
  `resolve` in interface `ResolvableDeserializer`
Parameters:
  `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
Throws:
  `JsonMappingException`

#### _findCustomDeser

    protected JsonDeserializer<Object> _findCustomDeser(DeserializationContext ctxt,
                                            JavaType type)
                                                 throws JsonMappingException

Throws:
  `JsonMappingException`

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                       BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### _withResolved

    protected JsonDeserializer<?> _withResolved(JsonDeserializer<?> mapDeser,
                                    JsonDeserializer<?> listDeser,
                                    JsonDeserializer<?> stringDeser,
                                    JsonDeserializer<?> numberDeser)

#### deserialize

    public Object deserialize(JsonParser jp,
                     DeserializationContext ctxt)
                       throws IOException,
                              JsonProcessingException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `jp` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`
  `JsonProcessingException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser jp,
                             DeserializationContext ctxt,
                             TypeDeserializer typeDeserializer)
                               throws IOException,
                                      JsonProcessingException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<Object>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`
  `JsonProcessingException`

#### mapArray

    protected Object mapArray(JsonParser jp,
                  DeserializationContext ctxt)
                       throws IOException,
                              JsonProcessingException

Method called to map a JSON Array into a Java value.

Throws:
  `IOException`
  `JsonProcessingException`

#### mapObject

    protected Object mapObject(JsonParser jp,
                   DeserializationContext ctxt)
                        throws IOException,
                               JsonProcessingException

Method called to map a JSON Object into a Java value.

Throws:
  `IOException`
  `JsonProcessingException`

#### mapArrayToArray

    protected Object[] mapArrayToArray(JsonParser jp,
                           DeserializationContext ctxt)
                                throws IOException,
                                       JsonProcessingException

Method called to map a JSON Array into a Java Object array (Object[]).

Throws:
  `IOException`
  `JsonProcessingException`